///home/berryj/link/bin/genMethods "-g" "-t" "Graph*" "-h" "SortedList" "-r" "List<Graph*>" "-I" "LINK/basic/List.h" "-I" "LINK/graph/Graph.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/graph/Graph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Graph* _Graph_;
typedef SortedList<Graph* > _SortedList_Graph__;
static SortedList<Graph* > s__SortedList_Graph__;

#define _SortedList_Graph__DATA(x) ((SortedList<Graph* >*) (EXTDATA(x)))
#define _SortedList_Graph__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Graph* > >::type))
#define _SortedList_Graph__ISNT_DATA(x) (!_SortedList_Graph__IS_DATA(x))

#define _SortedList_Graph__CXX_DATA(x) (*(SortedList<Graph* >*) (EXTDATA(VAL(x))))
#define _SortedList_Graph__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Graph* > >::type))
#define _SortedList_Graph__CXX_ISNT_DATA(x) (!_SortedList_Graph__CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedList_Graph__()
{
	Wrapper<_SortedList_Graph__>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedList_Graph__>::name, 
			Wrapper<List<Graph*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Graph_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Graph_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Graph_>::freeTypedList);
	Tcl_InitHashTable(&Register<_SortedList_Graph__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedList_Graph__Methods(void);

PRIMITIVE STk_init_methods__SortedList_Graph__()
{
	genExtra_SortedList_Graph__Methods();
	return UNDEFINED;
}
